require_relative "listing"

module NwmlsClient

  class Amenity < Listing

    def initialize(config, criteria = {})
      criteria[:operation] = :retrieve_amenity_data
      criteria[:data_response] = :retrieve_amenity_data_response
      criteria[:data_result] = :retrieve_amenity_data_result
      criteria[:data_types] = :amenities
      criteria[:data_type] = :amenity
      @criteria = criteria 
      super(config, @criteria)    
    end 

    def display(amenities)
      amenity = amenities

      if amenity.is_a?(Array)
        #puts "Property type: #{amenities[:property_type]}"
        amenity.each do |item|
          item.each do |key, value|
            if key.to_s == "values"
              puts "#{key}: Code: #{value[:code]} -- Description: #{value[:description]}"
            else
              puts "#{key}: #{value}"
            end
          end
        end
      end        
    end

  end
  
end

if __FILE__ == $0
  config = NwmlsClient::Base.load_config
  amenity = NwmlsClient::Amenity.new(config)
  data = amenity.retrieve_data
  amenity.display(data)
end