require_relative "listing"

module NwmlsClient

  class Community < Listing

    def initialize(config, criteria = {})
      criteria[:operation] = :retrieve_area_community_data
      criteria[:data_response] = :retrieve_area_community_data_response
      criteria[:data_result] = :retrieve_area_community_data_result
      criteria[:data_types] = :areas_communities
      criteria[:data_type] = :areacommunity
      @criteria = criteria 
      super(config, @criteria)    
    end 

    def display(community_data)

      if community_data.is_a?(Array)
        community_data.each do |item|
          item.each do |key, value|
            puts "#{key}: #{value}"
          end
          puts "\n"
        end
      end        
    end

  end
  
end


if __FILE__ == $0
  config = NwmlsClient::Base.load_config
  community = NwmlsClient::Community.new(config)
  data = community.retrieve_data
  community.display(data)
end