require_relative "listing"

module NwmlsClient

  class History < Listing

    def initialize(config, criteria = {})
      criteria[:operation] = :retrieve_listing_history_data
      criteria[:data_response] = :retrieve_listing_history_data_response
      criteria[:data_result] = :retrieve_listing_history_data_result
      criteria[:data_types] = :listing_history
      criteria[:data_type] = :history
      @criteria = criteria 
      super(config, @criteria)    
    end 

    def display(history_data)

      if history_data.is_a?(Array)
        history_data.each do |item|
          item.each do |key, value|
            if key.to_s == "ml_number"
              puts "\n#{key}: #{value}"
            else
              if value.is_a?(Array)
                value.each do |item2|
                  puts "list price: #{item2[:list_price]} change date: #{item2[:change_date]}"                
                end
              else
                puts "list price: #{value[:list_price]} change date: #{value[:change_date]}"
              end
            end 
          end
        end
      end        
    end

  end
  
end

  
if __FILE__ == $0
  config = NwmlsClient::Base.load_config
  b_date = DateTime.now-5
  history = NwmlsClient::History.new(config, begin_date: b_date)
  data = history.retrieve_data
  #puts "#{data}"
  history.display(data)
end