require_relative "listing"

module NwmlsClient

  class ImageData < Listing

    def initialize(config, criteria = {})
      criteria[:operation] = :retrieve_image_data
      criteria[:data_response] = :retrieve_image_data_response
      criteria[:data_result] = :retrieve_image_data_result
      criteria[:data_types] = :images
      criteria[:data_type] = :image
      @criteria = criteria 
      super(config, @criteria)    
    end 

    def display(image_data)

      if image_data.is_a?(Array)
        image_data.each do |item|
          item.each do |key, value|
            puts "#{key}: #{value}"
          end
          puts "\n"
        end
      end        
    end

  end
  
end

if __FILE__ == $0
  config = NwmlsClient::Base.load_config
  image_data = NwmlsClient::ImageData.new(config)
  data = image_data.retrieve_data
  image_data.display(data)
end