require_relative "listing"

module NwmlsClient

  class Member < Listing

    def initialize(config, criteria = {})
      criteria[:operation] = :retrieve_member_data
      criteria[:data_response] = :retrieve_member_data_response
      criteria[:data_result] = :retrieve_member_data_result
      criteria[:data_types] = :members
      criteria[:data_type] = :member
      @criteria = criteria 
      super(config, @criteria)    
    end 

    def display(member_data)

      if member_data.is_a?(Array)
        member_data.each do |item|
          item.each do |key, value|
            puts "#{key}: #{value}"
          end
          puts "\n"
        end
      end
    end

  end
  
end

if __FILE__ == $0
  config = NwmlsClient::Base.load_config
  member = NwmlsClient::Member.new(config)
  data = member.retrieve_data
  #puts "#{data}"
  member.display(data)
end