require_relative "listing"

module NwmlsClient

  class Office < Listing

    def initialize(config, criteria = {})
      criteria[:operation] = :retrieve_office_data
      criteria[:data_response] = :retrieve_office_data_response
      criteria[:data_result] = :retrieve_office_data_result
      criteria[:data_types] = :offices
      criteria[:data_type] = :office
      @criteria = criteria 
      super(config, @criteria)    
    end 

    def display(office_data)

      if office_data.is_a?(Array)
        office_data.each do |item|
          item.each do |key, value|
            puts "#{key}: #{value}"
          end
          puts "\n"
        end
      end
    end

  end
  
end

if __FILE__ == $0
  config = NwmlsClient::Base.load_config
  office = NwmlsClient::Office.new(config)
  data = office.retrieve_data
  #puts "#{data}"
  office.display(data)
end