require_relative "listing"

module NwmlsClient

  class School < Listing

    def initialize(config, criteria = {})
      criteria[:operation] = :retrieve_school_data
      criteria[:data_response] = :retrieve_school_data_response
      criteria[:data_result] = :retrieve_school_data_result
      criteria[:data_types] = :schools
      criteria[:data_type] = :school
      @criteria = criteria 
      super(config, @criteria)    
    end 

    def display(school_data)

      if school_data.is_a?(Array)
        school_data.each do |item|
          item.each do |key, value|
            puts "#{key}: #{value}"
          end
          puts "\n"
        end
      end
    end

  end
  
end

if __FILE__ == $0
  config = NwmlsClient::Base.load_config
  school = NwmlsClient::School.new(config)
  data = school.retrieve_data
  #puts "#{data}"
  school.display(data)
end